from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Array, Int, Boolean, String

Tombo_Write_Most_Significant_Fasta_V0_1_0 = CommandToolBuilder(tool="tombo_write_most_significant_fasta", base_command=["tombo", "write_most_significant_fasta"], inputs=[ToolInput(tag="in_file_saveload_base", input_type=File(optional=True), prefix="--statistics-filename", doc=InputDocumentation(doc="File to save/load base by base statistics.")), ToolInput(tag="in_fast_five_based_irs", input_type=Array(t=Int(), optional=True), prefix="--fast5-basedirs", doc=InputDocumentation(doc="Directories containing fast5 files.")), ToolInput(tag="in_genome_fast_a", input_type=File(optional=True), prefix="--genome-fasta", doc=InputDocumentation(doc="FASTA file used to re-squiggle. For faster sequence\naccess.")), ToolInput(tag="in_statistic_order", input_type=Boolean(optional=True), prefix="--statistic-order", doc=InputDocumentation(doc="Order selected locations by p-values or mean\nlikelihood ratio. Default: fraction of significant\nreads.")), ToolInput(tag="in_num_regions", input_type=Int(optional=True), prefix="--num-regions", doc=InputDocumentation(doc="Number of regions to plot. Default: 100")), ToolInput(tag="in_num_bases", input_type=Int(optional=True), prefix="--num-bases", doc=InputDocumentation(doc="Number of bases to plot/output. Default: 21")), ToolInput(tag="in_q_value_threshold", input_type=Int(optional=True), prefix="--q-value-threshold", doc=InputDocumentation(doc="Plot all regions below provied q-value. Overrides\n--num-regions.")), ToolInput(tag="in_sequences_filename", input_type=File(optional=True), prefix="--sequences-filename", doc=InputDocumentation(doc="File for sequences from selected regions. Sequences\nwill be stored in FASTA format. Default:\ntombo_results.significant_regions.fasta.")), ToolInput(tag="in_corrected_group", input_type=Int(optional=True), prefix="--corrected-group", doc=InputDocumentation(doc="FAST5 group created by resquiggle command. Default:\nRawGenomeCorrected_000")), ToolInput(tag="in_base_call_subgroups", input_type=Array(t=String(), optional=True), prefix="--basecall-subgroups", doc=InputDocumentation(doc="FAST5 subgroup(s) (under Analyses/[corrected-group])\ncontaining basecalls. Default: ['BaseCalled_template']")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Don't print status information.")), ToolInput(tag="in_var_11", input_type=String(), position=0, doc=InputDocumentation(doc="[--fast5-basedirs FAST5_BASEDIRS [FAST5_BASEDIRS ...]]"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Tombo_Write_Most_Significant_Fasta_V0_1_0().translate("wdl", allow_empty_container=True)

